/* 
GA for Skill Based Resourse Allocation

Author : Dipti Gagneja (di_gagneja@hotmail.com)
  Done as part of AI Assignment under the guidance of Dr. S.B. Nair , Year : 2006

File name : ga.h

Abstract
  Declarations for functions used in ga_mainc, ga.c
*/


#define MAX 6
#define MAX1 102

int population_size;
int no_of_children;

float pC;			//Crossover Probability
float pM;			//Mutation Probability

float wt_skill;
float wt_budget;
float wt_pref;

int no_of_projects;
int no_of_employees;
int no_of_skills;
int total_req;
int *project_skill[MAX];
int *employee_skill[MAX];
int *project_team_size;
double *project_budget;
int *project_hours;
double *employee_cost;
int *pref_project;
int *new_team_size;
double *project_profit;

int *flagt;
int *vflag;
double *p;

/*A chromosome element - GENE -consist of an integer employee id and project id
and a pointer to the next gene of the chromosome*/

struct chromosome_element
{
	int project_id;
	int employee_id;
	struct chromosome_element *next;
};

typedef struct chromosome_element gene;

/* Temporary gene variable used throughout the GA*/

gene *temp,*temph,*tempv,*tempf,*tempd,*tempp,*tempr;
gene *temp1,*temp2;


/*Structure of header node for a chromosome 
consist of a double type fitness value, and pointer to the first gene*/
struct chromosome_header 
{
	double fitness;
	gene *first;
};

typedef struct chromosome_header header;

/* Temporary population variable used throughout the GA*/

header *population[MAX1], *start,*tempa,*parent1,*parent2,*child1,*child2;
header *children[MAX1],*parent[MAX1];


/************Function declrations ***************/



int query_records();																/*queries records from the database*/
void initialize();																	/*initializees a population*/
void create_gene(gene *temp,int current_project_id,int no_of_genes,int team_size);	/*creates genes for a chromosome*/
void validate(header *start);														/*validates a chromosome*/
void alter_team_size();																/*alters team size*/

double cal_fitness(header *start);													/*calculates fitness of chromosome*/
double skill_match(header *start);													/*returns penalty due to skill mismatch*/
double distribution_penalty(header *start);											/*returns penalty due wrong distribution*/
double budget_penalty(header *start);												/*returns penalty due to budget overflow*/
double project_cost1(int project_id ,header *start);									/*returns cost of project */
double preference_penalty(header *start);											/*returns penalty due to alloctionof employees to non preffered projects*/

void arrange(header *pop[],int no_of_chr);										/*sorts chromosomes according to increasing penalty*/
void print_chromosome();


void crossover();									/*generates chilren after crossover*/
void set_parent(header *start,int set_id);			/*sets chromosomes as parents*/
void rotate_c(header *start,int rotate_amount);		/*rotates a chromosome*/
void mutation();									/*mutates a chromosome*/
void new_generation();								/*generate ne generation from parents and children*/


unsigned int rand1();								/* returns a random integer */
void init1( unsigned int );							/* initialize the generator */
int ga_random_int(int start,int end);				/*returns an random integer*/
float ga_random_float();							/*returns a random float b/w 0&1*/

double penalty_stat();								/*returns average penalty of a population*/

void release_memory();
