
/******SKILL BASED RESOURCE ALLOCATION USING GENETIC ALGORITHM ******/

/* 
GA for Skill Based Resource Allocation

Author : Dipti Gagneja (di_gagneja@hotmail.com)
  Done as part of AI Assignment under the guidance of Dr. S.B. Nair , Year : 2006

File name : ga_main.c 

Abstract
	Defines the main function which implements the overall algorithm 
*/

#include <stdio.h>
#include "ga.h"

void main()
{
	int counter=0,no_of_generation=0;
	int max_gen;
	int pop_counter;

	/*Query recors from the database*/
	if(query_records()){
	
	if(no_of_employees<total_req)
	{
		/*If the available number of employees is less 
		alter the immediate required team size and budget*/

		printf("\nTotal requirement of employees is less than the available\n");
		printf(" Altering the immediate requirements\n");
		alter_team_size();
	}

	/*Ask user for the importance of each constraint - a weight raging from 0-1*/

	printf("\nEnter importance of the following constraints (Rate between 0-1)\n");
	printf("Skill Matching : ");
	scanf("%f",&wt_skill);
	printf("Budget :");
	scanf("%f",&wt_budget);
	printf("Preference of employees : ");
	fflush(stdin);
	scanf("%f",&wt_pref);
	fflush(stdin);
	
	/*Ask user to enter the preferred evolutionary parameters*/

	printf("\nEnter the following Evolutionary parameters\n");
	printf("\n\nEnter the population size : ");
	scanf("%d",&population_size);

	
	printf("Enter crossover frequency :");
	scanf("%f",&pC);
	printf("Enter Mutation frequency :");
	scanf("%f",&pM);
	
	printf("Enter Maximum number of generations  : ");
	scanf("%d",&max_gen);


	/*Initialize population*/
	
	initialize();
	
	/*Calculate fitness for each chromosome*/

	for(counter=1;counter<=population_size;counter++)
		population[counter]->fitness = cal_fitness(population[counter]);
	
	/*arrange the chromosomes in increasing fitness (decreasing penalty)*/
	arrange(population,population_size);

	printf("\n\nGen\t\tBEST\t\tWORST\t\tAVG\n\n");
	
	/*Repeat the process of generating children and hence the new generation till maximum number of generations*/
	for(no_of_generation=1;no_of_generation<=max_gen;no_of_generation++)
	{
			/*Crossover operation*/
			crossover();

			/*Mutaion operation*/
			mutation();

			/*Arrange the generated children in decreasing order of fitness*/
			arrange(children,no_of_children);

			/*Create new genration from parent and children chromosomes*/
			new_generation();
	
			/*Print the best, worst and Average fitness after every 50 Generations */
			if(no_of_generation%50 == 0)
			{
				printf("%d\t\t",no_of_generation);
				printf("%0.5f\t\t",population[1]->fitness);
				printf("%0.5f\t\t",population[population_size]->fitness);
				printf("%0.5f\n",penalty_stat());
			}
	}

	/*Output the best chromsome,presently the first one in the population 
	(arranged in decreasing order of fitness)*/

	temp=population[1]->first;
	printf("\n\nBest Chromosome \n");
	pop_counter =1;
	while(temp!=NULL)
	{
		
		pop_counter=temp->project_id;
		printf("\n\nProject %d\n",pop_counter);
		printf("Employee Allocated : ");
		while(temp!=NULL && temp->project_id == pop_counter)
		{
			printf("%d  ",temp->employee_id);
			temp=temp->next;
		}
		if((project_cost1(pop_counter,population[1]) - project_budget[pop_counter]) <0)
		{
			printf("\nExtra Budget : ");
			printf("%0.2f\n", -(project_cost1(pop_counter,population[1]) - project_budget[pop_counter]));
		}
		else	
		{
			printf("\nOver Budget by : ");
			printf("%0.2f\n",project_cost1(pop_counter,population[1]) - project_budget[pop_counter]);
		}
	}
	
}
}
