/* 
GA for Skill based Resource Allocation

Author : Dipti Gagneja (di_gagneja@hotmail.com)
  Done as part of AI Assignment under the guidance of Dr. S.B. Nair , Year : 2006

  
File Name : Query_db.c 

Abstract
	Implements the functions to query the database to read the employee information 
*/

#include <windows.h>
#include <sqlext.h>
#include <sql.h>
#include <math.h>
#include "ga.h"
#include <stdio.h>
#include <stdlib.h>
#include<malloc.h>


/***************QUERY RECORDS FROM DATABASE*********************/

int query_records()
{

	HENV hEnv = NULL; //for allocating memory usingSQLAllocEnv
	HDBC hDBC = NULL; //connection handle
	HSTMT hStmt = NULL; // statement handle

	UCHAR szDSN[SQL_MAX_DSN_LENGTH] = "employee";
	UCHAR* szUID = "ga"; //username of the database
	UCHAR* szPasswd = "ga"; //password of the database

	SDWORD cbModel;
	SDWORD cbModel1;
	SDWORD cbModel2;

	SWORD szModel;
	SWORD szModel1;
	SWORD szModel2;
	SDOUBLE szModel3;

	RETCODE retcode;
	int counter, counter1, counter2,no=1;

	// Allocate memory for ODBC Environment handle
	SQLAllocEnv (&hEnv);
	SQLAllocConnect (hEnv, &hDBC);

	//connecting to the database
	retcode = SQLConnect(hDBC,szDSN,SQL_NTS,szUID,SQL_NTS,szPasswd,SQL_NTS);

	//retcode will hold 1 if connection is established else -1

	printf("Connecting to the database\n");
	for(counter1=0;counter1<10;counter1++)
	{
		for(counter2=0;counter2<100;counter2++);
		printf(".");
	}



	if (retcode == SQL_SUCCESS || retcode == SQL_SUCCESS_WITH_INFO)
	{

/* Querying number of available employees*/
			
		retcode = SQLAllocStmt (hDBC, &hStmt);
		retcode = SQLExecDirect(hStmt,"SELECT count(emp_no) FROM employee ",SQL_NTS);	
		SQLBindCol(hStmt, no, SQL_C_SHORT, &szModel, 0,&cbModel);
		retcode = SQLFetch (hStmt);
		while (retcode == SQL_SUCCESS || retcode ==SQL_SUCCESS_WITH_INFO)
		{
			no_of_employees = szModel;
			retcode =SQLFetch(hStmt);
		}
		SQLFreeStmt (hStmt, SQL_DROP);
		printf("\nNo of employees : %d\n",no_of_employees);

		
/*Querying number of projects*/

		retcode = SQLAllocStmt (hDBC, &hStmt);
		retcode = SQLExecDirect(hStmt,"SELECT count(project_id) FROM project ",SQL_NTS);	
		SQLBindCol(hStmt, no, SQL_C_SHORT, &szModel, 0,&cbModel);
		retcode = SQLFetch (hStmt);
		while (retcode == SQL_SUCCESS || retcode ==SQL_SUCCESS_WITH_INFO)
		{
			no_of_projects = szModel;
			retcode =SQLFetch(hStmt);
		}
		SQLFreeStmt (hStmt, SQL_DROP);
		printf("No of projects : %d\n",no_of_projects);



/*Querying number of skills in the skill set*/

		retcode = SQLAllocStmt (hDBC, &hStmt);
		retcode = SQLExecDirect(hStmt,"SELECT count(skill_id) FROM skill_set ",SQL_NTS);	
		SQLBindCol(hStmt, no, SQL_C_SHORT, &szModel, 0,&cbModel);
		retcode = SQLFetch (hStmt);
		while (retcode == SQL_SUCCESS || retcode ==SQL_SUCCESS_WITH_INFO)
		{
			no_of_skills = szModel;
			retcode =SQLFetch(hStmt);
		}
		SQLFreeStmt (hStmt, SQL_DROP);
		printf("No of skills : %d\n",no_of_skills);

/*Querying team size for each project*/

		project_team_size = malloc((no_of_projects)*4);

		retcode = SQLAllocStmt (hDBC, &hStmt);
		retcode = SQLExecDirect(hStmt,"SELECT team_size FROM project order by project_id",SQL_NTS);	
		SQLBindCol(hStmt, no, SQL_C_SHORT, &szModel, 0,&cbModel);
		retcode = SQLFetch (hStmt);
		counter=1;
		while (retcode == SQL_SUCCESS || retcode ==SQL_SUCCESS_WITH_INFO)
		{
			project_team_size[counter] = szModel;
			total_req+=project_team_size[counter];
			counter++;
			retcode =SQLFetch(hStmt);
		}
		SQLFreeStmt (hStmt, SQL_DROP);

	


/*Querying budget for each project*/

		project_budget = malloc((no_of_projects)*8);

		retcode = SQLAllocStmt (hDBC, &hStmt);
		retcode = SQLExecDirect(hStmt,"SELECT budget FROM project order by project_id ",SQL_NTS);	
		SQLBindCol(hStmt, no, SQL_C_DOUBLE, &szModel3, 0,&cbModel);
		retcode = SQLFetch (hStmt);
		counter=1;
		while (retcode == SQL_SUCCESS || retcode ==SQL_SUCCESS_WITH_INFO)
		{
			project_budget[counter] = szModel3;
			counter++;
			retcode =SQLFetch(hStmt);
		}
		SQLFreeStmt (hStmt, SQL_DROP);
		
					

/*Querying number of hours per employee for each project*/

		project_hours = malloc((no_of_projects)*4);

		retcode = SQLAllocStmt (hDBC, &hStmt);
		retcode = SQLExecDirect(hStmt,"SELECT duration FROM project order by project_id",SQL_NTS);	
		SQLBindCol(hStmt, no, SQL_C_SHORT, &szModel, 0,&cbModel);
		retcode = SQLFetch (hStmt);
		counter=1;
		while (retcode == SQL_SUCCESS || retcode ==SQL_SUCCESS_WITH_INFO)
		{
			project_hours[counter] = szModel;
			counter++;
			retcode =SQLFetch(hStmt);
		}
		SQLFreeStmt (hStmt, SQL_DROP);


/*Querying profit for each project*/
		
		project_profit = malloc((no_of_projects)*8);

		retcode = SQLAllocStmt (hDBC, &hStmt);
		retcode = SQLExecDirect(hStmt,"SELECT profit FROM project order by project_id",SQL_NTS);	
		SQLBindCol(hStmt, no, SQL_C_DOUBLE, &szModel3, 0,&cbModel);
		retcode = SQLFetch (hStmt);
		counter=1;
		while (retcode == SQL_SUCCESS || retcode ==SQL_SUCCESS_WITH_INFO)
		{
			project_profit[counter] = szModel3;
			counter++;
			retcode =SQLFetch(hStmt);
		}
		SQLFreeStmt (hStmt, SQL_DROP);

	
	

/*Querying cost(per hour) for each employee*/

		employee_cost = malloc((no_of_employees)*8);
		

		retcode = SQLAllocStmt (hDBC, &hStmt);
		retcode = SQLExecDirect(hStmt,"SELECT emp_cost FROM employee ",SQL_NTS);	
		SQLBindCol(hStmt, no, SQL_C_DOUBLE, &szModel3, 0,&cbModel);
		retcode = SQLFetch (hStmt);
		counter=1;
	
		while (retcode == SQL_SUCCESS || retcode ==SQL_SUCCESS_WITH_INFO)
		{
			employee_cost[counter] = szModel3;
			counter++;
			retcode =SQLFetch(hStmt);
		}
		SQLFreeStmt (hStmt, SQL_DROP);

	
/*Querying preferred project for each employee*/

		pref_project = malloc((no_of_employees)*4);
		retcode = SQLAllocStmt (hDBC, &hStmt);
		retcode = SQLExecDirect(hStmt,"SELECT pref_project FROM employee ",SQL_NTS);	
		SQLBindCol(hStmt, no, SQL_C_SHORT, &szModel, 0,&cbModel);
		retcode = SQLFetch (hStmt);
		counter=1;
	
		while (retcode == SQL_SUCCESS || retcode ==SQL_SUCCESS_WITH_INFO)
		{
			pref_project[counter] = szModel;
			counter++;
			retcode =SQLFetch(hStmt);
		}
		SQLFreeStmt (hStmt, SQL_DROP);

	

/*Querying skill requirements for each project*/

		for(counter=1;counter<=no_of_skills;counter++)
				project_skill[counter] = malloc((no_of_projects+1)*4);
		

		for(counter1=1;counter1<=no_of_skills;counter1++)
			for(counter2=1;counter2<=no_of_projects;counter2++)
				project_skill[counter1][counter2]=0;

		retcode = SQLAllocStmt (hDBC, &hStmt);
		retcode = SQLExecDirect(hStmt,"SELECT * FROM project_skill",SQL_NTS);	
		SQLBindCol(hStmt, no, SQL_C_SHORT, &szModel, 0,&cbModel);
		SQLBindCol(hStmt, no+1, SQL_C_SHORT, &szModel1, 0,&cbModel1);
		SQLBindCol(hStmt, no+2, SQL_C_SHORT, &szModel2, 0,&cbModel2);
		retcode = SQLFetch (hStmt);

		while (retcode == SQL_SUCCESS || retcode ==SQL_SUCCESS_WITH_INFO)
		{
			project_skill[szModel1][szModel]=szModel2;
			retcode =SQLFetch(hStmt);
		}
		SQLFreeStmt (hStmt, SQL_DROP);

	
/*Querying skill requirements for each employee*/

		for(counter=1;counter<=no_of_skills;counter++)
				employee_skill[counter] = malloc((no_of_employees+1)*4);
		
		for(counter1=1;counter1<=no_of_skills;counter1++)
			for(counter2=1;counter2<=no_of_employees;counter2++)
				employee_skill[counter1][counter2]=0;

		retcode = SQLAllocStmt (hDBC, &hStmt);
		retcode = SQLExecDirect(hStmt,"SELECT * FROM employee_skill",SQL_NTS);	
		SQLBindCol(hStmt, no, SQL_C_SHORT, &szModel, 0,&cbModel);
		SQLBindCol(hStmt, no+1, SQL_C_SHORT, &szModel1, 0,&cbModel1);
		SQLBindCol(hStmt, no+2, SQL_C_SHORT, &szModel2, 0,&cbModel2);
		retcode = SQLFetch (hStmt);

		while (retcode == SQL_SUCCESS || retcode ==SQL_SUCCESS_WITH_INFO)
		{
			employee_skill[szModel1][szModel]=szModel2;
			retcode =SQLFetch(hStmt);
		}
		SQLFreeStmt (hStmt, SQL_DROP);

		SQLDisconnect (hDBC);
	}
	else
	{
		printf("Cannot read the database\n");
		return 0;
	}
	SQLFreeConnect (hDBC);
	SQLFreeEnv (hEnv);
	return 1;

}
