/* 
GA for Skill based Resource Allocation

Author : Dipti Gagneja (di_gagneja@hotmail.com)
  Done as part of AI Assignment under the guidance of Dr. S.B. Nair , Year : 2006

  
File Name : random_gen.c 

Abstract
  Defines functions to return random numbers used throughout the GA. 
  The function can return either a random 32-bit integer or a random float in [0 1)
  period = 2^800
*/

#define N 25
#define M 7




/* return a random float >= 0 and < 1 */

#define rand_float          ((double)rand() / 4294967296.0)


static unsigned int seed_array[N];         /* the 25 seeds */


/* Initialize the random seed*/
void init1( unsigned int seed )
{
   int counter;

   seed_array[0] = (seed|1) & 0xffffffff;
   for (counter=1; counter<N; counter++)
      seed_array[counter] = (69069 * seed_array[counter-1]) & 0xffffffff;
}

/* Generate the random float */
unsigned int rand1()
{
	unsigned int random_number;
	static unsigned int mag01[2]={ 0x0, 0x8ebfd028};  /* "magic" vector */
	static int counter1 = 0;
	int counter2;

	if (counter1==N)
	{
		for (counter2=0; counter2 < N-M; counter2++)
			seed_array[counter2] = seed_array[counter2+M] ^ (seed_array[counter2] >> 1) ^ mag01[seed_array[counter2] & 1];

		for (; counter2 < N; counter2++)
			seed_array[counter2] = seed_array[counter2+(M-N)] ^ (seed_array[counter2] >> 1) ^ mag01[seed_array[counter2] & 1];

		counter1=0;
	}
   random_number = seed_array[counter1++];
   random_number ^= (random_number << 7) & 0x2b5b2500;
   random_number ^= (random_number << 15) & 0xdb8b0000;
   random_number &= 0xffffffff;     
   random_number ^= (random_number >> 16);
   return random_number;
}






